// CustomClockSettings.cpp : implementation file
//

#include "stdafx.h"
#include "serial758ui.h"
#include "CustomClockSettings.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCustomClockSettings dialog


CCustomClockSettings::CCustomClockSettings(CWnd* pParent /*=NULL*/)
	: CDialog(CCustomClockSettings::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCustomClockSettings)
	m_editNewClockRate = _T("");
	//}}AFX_DATA_INIT
}


void CCustomClockSettings::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustomClockSettings)
	DDX_Text(pDX, IDC_EDIT_NEW_CLOCK_RATE, m_editNewClockRate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCustomClockSettings, CDialog)
	//{{AFX_MSG_MAP(CCustomClockSettings)
	ON_BN_CLICKED(IDC_BUTTON_SET_NEW_CLOCK_RATE, OnButtonSetNewClockRate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCustomClockSettings message handlers

void CCustomClockSettings::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

BOOL CCustomClockSettings::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	DWORD dwStatus, dwType, dwSize, dwCustomClockRate;
	
	
	HKEY hk;

	dwStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
                            TEXT("System\\CurrentControlSet\\Services\\Ser15x"),
                            0,
                            KEY_READ,
                            &hk);

	if(dwStatus != ERROR_SUCCESS) 
	{
		//
		// No Key means, no driver is installed.
		//
		MessageBox("The driver is not installed, so you can not set Custom Clock", "ERROR", MB_OK);
		// don't launch the dialog box
		CDialog::OnOK();
		return TRUE;
	}
	
	dwSize = sizeof(DWORD);
	
	dwStatus = RegQueryValueEx(hk, TEXT("ClockRateFor25x"), NULL, &dwType, (LPBYTE)&dwCustomClockRate, &dwSize);
	
	if(dwStatus != ERROR_SUCCESS || dwType != REG_DWORD) 
	{
		//
		// Since the key is not available, set the default to 24 MHz 
		//		
		dwCustomClockRate = 24000000;				
	}
	
	CString str;
	str.Format("%d Hz", dwCustomClockRate);
	SetDlgItemText(IDC_STATIC_CURRENT_CLOCK_RATE, str);

	str.Format("%d", dwCustomClockRate);
//	m_editNewClockRate = dwCustomClockRate;
	
	RegCloseKey(hk);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCustomClockSettings::OnButtonSetNewClockRate() 
{
	// TODO: Add your control notification handler code here
	DWORD dwStatus, dwSize, dwCustomClockRate;
	HKEY hk;
	char *stopstring;
	CString str;

	UpdateData (TRUE);
	
	if ( !m_editNewClockRate.GetLength() )
	{
		MessageBox("Please input a proper clock value!", "Warning! Improper value to Write", MB_OK|MB_ICONEXCLAMATION);			
		return;
	}		

	dwCustomClockRate = strtoul( m_editNewClockRate, &stopstring, 10 );
	
	dwStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE,
                            TEXT("System\\CurrentControlSet\\Services\\Ser15x"),
                            0,
                            KEY_WRITE,
                            &hk);

	if(dwStatus != ERROR_SUCCESS) 
	{
		//
		// No Key means, no driver is installed.
		// This should not happen as init dialog fails in this case
		// just another check
		//
		MessageBox("The driver is not installed, so you can not set Custom Clock", "ERROR", MB_OK);
		// don't launch the dialog box
		CDialog::OnOK();
		return ;
	}
	
	dwSize = sizeof(DWORD);
	
	RegSetValueEx (hk, TEXT("ClockRateFor25x"), 0, REG_DWORD, (BYTE *)&dwCustomClockRate, sizeof(DWORD));
		
	str.Format("%d Hz", dwCustomClockRate);
	SetDlgItemText(IDC_STATIC_CURRENT_CLOCK_RATE, str);
	
	RegCloseKey(hk);	
}
