// Serial758UI.cpp : Defines the class behaviors for the application.
//A multi document app wizard is selected for our application. 

#include "stdafx.h"
#include "Serial758UI.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "Serial758UIDoc.h"
#include "Serial758UIView.h"
#include "PortPage.h"
#include "PortSheet.h"
#include "SerialCommTestDlg.h"
#include "UserDataDlg.h"
#include "GlobalVar.h"
#include "DelayDlg.h"
#include "CustomClockSettings.h"

#include <stdio.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSerialCommTestDlg* m_pSerialCommTestDlg;

TESTSTRUCT m_ParTest[MAXPORTS];
TRANSFERSTRUCT m_TransferDataDlg[MAXPORTS];
ERRCHECKSTRUCT m_structErrChecking[MAXPORTS];

/////////////////////////////////////////////////////////////////////////////
// CSerial758UIApp

BEGIN_MESSAGE_MAP(CSerial758UIApp, CWinApp)
	//{{AFX_MSG_MAP(CSerial758UIApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_TEST_START, OnTestStart)
	ON_COMMAND(ID_CONFIG_LOAD, OnConfigLoad)
	ON_COMMAND(ID_CONFIG_SAVE, OnConfigSave)
	ON_COMMAND(ID_TEST_STOP, OnTestStop)
	ON_UPDATE_COMMAND_UI(ID_TEST_STOP, OnUpdateTestStop)
	ON_COMMAND(ID_SETUP_PORTSETTINGS, OnSetupPortsettings)
	ON_UPDATE_COMMAND_UI(ID_SETUP_PORTSETTINGS, OnUpdateSetupPortsettings)
	ON_UPDATE_COMMAND_UI(ID_TEST_START, OnUpdateTestStart)
	ON_COMMAND(ID_CONFIG_HELP, OnConfigHelp)
	ON_UPDATE_COMMAND_UI(ID_CONFIG_LOAD, OnUpdateConfigLoad)
	ON_UPDATE_COMMAND_UI(ID_APP_EXIT, OnUpdateAppExit)
	ON_COMMAND(ID_TEST_DELAY, OnTestDelay)
	ON_COMMAND(ID_SETUP_CLOCKSETTING_FOR_66MHZ_25x, OnSETUPCLOCKSETTINGFOR66MHZ25x)
	ON_UPDATE_COMMAND_UI(ID_SETUP_CLOCKSETTING_FOR_66MHZ_25x, OnUpdateSETUPCLOCKSETTINGFOR66MHZ25x)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

////////////////////////////////////////////////////////////////////////////
// CSerial758UIApp construction

CSerial758UIApp::CSerial758UIApp()
{
	m_pSerialCommTestDlg=NULL;//The dialog pointer is first initialized to NULL
	m_bTestStart = TRUE;
	m_bTestStop = FALSE;  
	m_bSetUp = TRUE;
	m_bSetUpCustomClock = TRUE;
	//m_bStopPressed=FALSE;

	for(int n=0;n<MAXPORTS;n++)
	{
		m_ParTest[n].nErrCount=0;//initialize
		m_ParTest[n].nPacCount=0;//initialize
		m_ParTest[n].nLineCount=0;
		m_ParTest[n].bTestStop=FALSE;
		m_ParTest[n].bTestRun=FALSE;
		
		m_structErrChecking[n].ntempReadBytes=0;
		m_structErrChecking[n].bInCompleteRead=FALSE;
		m_structErrChecking[n].nFileIndex=0;
		m_structErrChecking[n].bFilePending=FALSE;
	}
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CSerial758UIApp object

CSerial758UIApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CSerial758UIApp initialization

BOOL CSerial758UIApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	// Change the registry key under which our settings are stored.
	// You should modify this string to be something appropriate
	// such as the name of your company or organization.
	SetRegistryKey(_T("Serial758UI"));

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_SERIALTYPE,
		RUNTIME_CLASS(CSerial758UIDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CSerial758UIView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	m_nCmdShow=SW_SHOWMAXIMIZED;//first time when the app starts , let the window be shown maximized
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	pMainFrame->GetClientRect(&m_ClientRect);
	
	//The app wizard created a single document to start with. So open the document and 
	//rename its title
	POSITION curTemplatePos= GetFirstDocTemplatePosition();

	pDocTemplate =(CMultiDocTemplate*)GetNextDocTemplate(curTemplatePos);
	
	POSITION CurPos = pDocTemplate->GetFirstDocPosition();
	
	if(CurPos!=NULL)
	{
		CDocument* pDoc=pDocTemplate->GetNextDoc(CurPos);
		CString StrTitle;
		StrTitle="XR17C15x UART PCI Card Test Application";
		pDoc->SetTitle(StrTitle);
	 }
	//m_structPortSettings is the name of the structure containing all the variables 
	//belonging to the port settings dialog. Initialize these for the first time.


	//code for updating the variables from the registry

	char cHrTime[5],cMinTime[5];//local variables

	m_structPortSettingsDlg[0].nPortOpen=GetProfileInt("Version 1.0","m_PortRegistry[0].nPortOpen",1);
	m_structPortSettingsDlg[0].nBaud= GetProfileInt("Version 1.0","m_PortRegistry[0].nBaud",13);
	m_structPortSettingsDlg[0].nDataBits=GetProfileInt("Version 1.0","m_PortRegistry[0].nDataBits",3);
	m_structPortSettingsDlg[0].nParity=GetProfileInt("Version 1.0","m_PortRegistry[0].nParity",4);
	m_structPortSettingsDlg[0].nStopBits=GetProfileInt("Version 1.0","m_PortRegistry[0].nStopBits",0);
	m_structPortSettingsDlg[0].nFlowCtrl=GetProfileInt("Version 1.0","m_PortRegistry[0].nFlowCtrl",2);
	m_structPortSettingsDlg[0].nComBase=GetProfileInt("Version 1.0","m_PortRegistry[0].nComBase",4);
	m_structPortSettingsDlg[0].nRS485=GetProfileInt("Version 1.0","m_PortRegistry[0].nRS485",0);
	m_structPortSettingsDlg[0].nIR=GetProfileInt("Version 1.0","m_PortRegistry[0].nIR",0);
	m_structPortSettingsDlg[0].nDTR=GetProfileInt("Version 1.0","m_PortRegistry[0].nDTR",0);
	m_structPortSettingsDlg[0].nDTRHys=GetProfileInt("Version 1.0","m_PortRegistry[0].nDTRHys",3);
	m_structPortSettingsDlg[0].nRTS=GetProfileInt("Version 1.0","m_PortRegistry[0].nRTS",1);
	m_structPortSettingsDlg[0].nRTSHys=GetProfileInt("Version 1.0","m_PortRegistry[0].nRTSHys",3);	
	m_structPortSettingsDlg[0].nTxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[0].nTxFIFO",0);
	m_structPortSettingsDlg[0].nTxTrig=GetProfileInt("Version 1.0","m_PortRegistry[0].nTxTrig",0);
	m_structPortSettingsDlg[0].nRxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[0].nRxFIFO",0);		
	m_structPortSettingsDlg[0].nRxTrig=GetProfileInt("Version 1.0","m_PortRegistry[0].nRxTrig",31);
	m_TransferDataDlg[0].nQuickBrown=GetProfileInt("Version 1.0","m_PortRegistry[0].nQuickBrown",0);
	m_TransferDataDlg[0].nAlpha=GetProfileInt("Version 1.0","m_PortRegistry[0].nAlpha",1);
	m_TransferDataDlg[0].nFile=GetProfileInt("Version 1.0","m_PortRegistry[0].nFile",0);
	m_TransferDataDlg[0].nUserData=GetProfileInt("Version 1.0","m_PortRegistry[0].nUserData",0);
	m_TestDlg[0].nTestForever=GetProfileInt("Version 1.0","m_PortRegistry[0].nTestForever",0);
	m_TestDlg[0].nStopTime=GetProfileInt("Version 1.0","m_PortRegistry[0].nStopTime",0);
	m_TestDlg[0].nStopError=GetProfileInt("Version 1.0","m_PortRegistry[0].nStopError",1);
	//m_TestDlg[0].nDisONOFF=GetProfileInt("Version 1.0","m_PortRegistry[0].nDisONOFF",0);
	m_TestDlg[0].nDisONOFF=m_structPortSettingsDlg[0].nPortOpen;
	m_TestDlg[0].nLoopTest=GetProfileInt("Version 1.0","m_PortRegistry[0].nLoopTest",0);
	m_itoaRegistry[0].strHrTime=GetProfileInt("Version 1.0","m_PortRegistry[0].strHrTime",1);
	m_itoaRegistry[0].strMinTime=GetProfileInt("Version 1.0","m_PortRegistry[0].strMinTime",10);


	if(m_TransferDataDlg[0].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
	{                                 //and not file
		m_TransferDataDlg[0].nFile=0;//dont select file transfer when the test dialog is opened for the first time
		m_TransferDataDlg[0].nAlpha=1;//by default if file is selected , check Alpha
	}

	itoa(m_itoaRegistry[0].strHrTime,cHrTime,10);
	m_TestDlg[0].strHrTime=cHrTime;
	itoa(m_itoaRegistry[0].strMinTime,cMinTime,10);
	m_TestDlg[0].strMinTime=cMinTime;
	
	m_TransferDataDlg[0].strUser="Exar Corporation\r\n";
	m_TestDlg[0].strTx="";
	m_TestDlg[0].strRx="";	

	m_Delay="10";

    m_structPortSettingsDlg[1].nPortOpen=GetProfileInt("Version 1.0","m_PortRegistry[1].nPortOpen",0);
	m_structPortSettingsDlg[1].nBaud= GetProfileInt("Version 1.0","m_PortRegistry[1].nBaud",13);
	m_structPortSettingsDlg[1].nDataBits=GetProfileInt("Version 1.0","m_PortRegistry[1].nDataBits",3);
	m_structPortSettingsDlg[1].nParity=GetProfileInt("Version 1.0","m_PortRegistry[1].nParity",4);
	m_structPortSettingsDlg[1].nStopBits=GetProfileInt("Version 1.0","m_PortRegistry[1].nStopBits",0);
	m_structPortSettingsDlg[1].nFlowCtrl=GetProfileInt("Version 1.0","m_PortRegistry[1].nFlowCtrl",2);
	m_structPortSettingsDlg[1].nComBase=GetProfileInt("Version 1.0","m_PortRegistry[1].nComBase",5);
	m_structPortSettingsDlg[1].nRS485=GetProfileInt("Version 1.0","m_PortRegistry[1].nRS485",0);
	m_structPortSettingsDlg[1].nIR=GetProfileInt("Version 1.0","m_PortRegistry[1].nIR",0);
	m_structPortSettingsDlg[1].nDTR=GetProfileInt("Version 1.0","m_PortRegistry[1].nDTR",0);
	m_structPortSettingsDlg[1].nDTRHys=GetProfileInt("Version 1.0","m_PortRegistry[1].nDTRHys",3);
	m_structPortSettingsDlg[1].nRTS=GetProfileInt("Version 1.0","m_PortRegistry[1].nRTS",1);
	m_structPortSettingsDlg[1].nRTSHys=GetProfileInt("Version 1.0","m_PortRegistry[1].nRTSHys",3);	
	m_structPortSettingsDlg[1].nTxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[1].nTxFIFO",0);
	m_structPortSettingsDlg[1].nTxTrig=GetProfileInt("Version 1.0","m_PortRegistry[1].nTxTrig",0);
	m_structPortSettingsDlg[1].nRxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[1].nRxFIFO",0);		
	m_structPortSettingsDlg[1].nRxTrig=GetProfileInt("Version 1.0","m_PortRegistry[1].nRxTrig",31);
	m_TransferDataDlg[1].nQuickBrown=GetProfileInt("Version 1.0","m_PortRegistry[1].nQuickBrown",0);
	m_TransferDataDlg[1].nAlpha=GetProfileInt("Version 1.0","m_PortRegistry[1].nAlpha",1);
	m_TransferDataDlg[1].nFile=GetProfileInt("Version 1.0","m_PortRegistry[1].nFile",0);
	m_TransferDataDlg[1].nUserData=GetProfileInt("Version 1.0","m_PortRegistry[1].nUserData",0);
	m_TestDlg[1].nTestForever=GetProfileInt("Version 1.0","m_PortRegistry[1].nTestForever",1);
	m_TestDlg[1].nStopTime=GetProfileInt("Version 1.0","m_PortRegistry[1].nStopTime",0);
	m_TestDlg[1].nStopError=GetProfileInt("Version 1.0","m_PortRegistry[1].nStopError",0);
	m_TestDlg[1].nLoopTest=GetProfileInt("Version 1.0","m_PortRegistry[1].nLoopTest",0);
	//m_TestDlg[1].nDisONOFF=GetProfileInt("Version 1.0","m_PortRegistry[1].nDisONOFF",0);
	m_TestDlg[1].nDisONOFF=m_structPortSettingsDlg[1].nPortOpen;
	m_itoaRegistry[1].strHrTime=GetProfileInt("Version 1.0","m_PortRegistry[1].strHrTime",2);
	m_itoaRegistry[1].strMinTime=GetProfileInt("Version 1.0","m_PortRegistry[1].strMinTime",20);

	if(m_TransferDataDlg[1].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
	{                                 //and not file
		m_TransferDataDlg[1].nFile=0;
		m_TransferDataDlg[1].nAlpha=1;
	}

	itoa(m_itoaRegistry[1].strHrTime,cHrTime,10);
	m_TestDlg[1].strHrTime=cHrTime;
	itoa(m_itoaRegistry[1].strMinTime,cMinTime,10);
	m_TestDlg[1].strMinTime=cMinTime;

	m_TransferDataDlg[1].strUser="Exar Corporation\r\n";
	m_TestDlg[1].strTx="";
	m_TestDlg[1].strRx="";
	
	m_structPortSettingsDlg[2].nPortOpen=GetProfileInt("Version 1.0","m_PortRegistry[2].nPortOpen",0);
	m_structPortSettingsDlg[2].nBaud= GetProfileInt("Version 1.0","m_PortRegistry[2].nBaud",13);
	m_structPortSettingsDlg[2].nDataBits=GetProfileInt("Version 1.0","m_PortRegistry[2].nDataBits",3);
	m_structPortSettingsDlg[2].nParity=GetProfileInt("Version 1.0","m_PortRegistry[2].nParity",4);
	m_structPortSettingsDlg[2].nStopBits=GetProfileInt("Version 1.0","m_PortRegistry[2].nStopBits",0);
	m_structPortSettingsDlg[2].nFlowCtrl=GetProfileInt("Version 1.0","m_PortRegistry[2].nFlowCtrl",2);
	m_structPortSettingsDlg[2].nComBase=GetProfileInt("Version 1.0","m_PortRegistry[2].nComBase",6);
	m_structPortSettingsDlg[2].nRS485=GetProfileInt("Version 1.0","m_PortRegistry[2].nRS485",0);
	m_structPortSettingsDlg[2].nIR=GetProfileInt("Version 1.0","m_PortRegistry[2].nIR",0);
	m_structPortSettingsDlg[2].nDTR=GetProfileInt("Version 1.0","m_PortRegistry[2].nDTR",0);
	m_structPortSettingsDlg[2].nDTRHys=GetProfileInt("Version 1.0","m_PortRegistry[2].nDTRHys",3);
	m_structPortSettingsDlg[2].nRTS=GetProfileInt("Version 1.0","m_PortRegistry[2].nRTS",1);
	m_structPortSettingsDlg[2].nRTSHys=GetProfileInt("Version 1.0","m_PortRegistry[2].nRTSHys",3);	
	m_structPortSettingsDlg[2].nTxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[2].nTxFIFO",0);
	m_structPortSettingsDlg[2].nTxTrig=GetProfileInt("Version 1.0","m_PortRegistry[2].nTxTrig",0);
	m_structPortSettingsDlg[2].nRxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[2].nRxFIFO",0);		
	m_structPortSettingsDlg[2].nRxTrig=GetProfileInt("Version 1.0","m_PortRegistry[2].nRxTrig",31);
	m_TransferDataDlg[2].nQuickBrown=GetProfileInt("Version 1.0","m_PortRegistry[2].nQuickBrown",0);
	m_TransferDataDlg[2].nAlpha=GetProfileInt("Version 1.0","m_PortRegistry[2].nAlpha",1);
	m_TransferDataDlg[2].nFile=GetProfileInt("Version 1.0","m_PortRegistry[2].nFile",0);
	m_TransferDataDlg[2].nUserData=GetProfileInt("Version 1.0","m_PortRegistry[2].nUserData",0);
	m_TestDlg[2].nTestForever=GetProfileInt("Version 1.0","m_PortRegistry[2].nTestForever",1);
	m_TestDlg[2].nStopTime=GetProfileInt("Version 1.0","m_PortRegistry[2].nStopTime",0);
	m_TestDlg[2].nStopError=GetProfileInt("Version 1.0","m_PortRegistry[2].nStopError",0);
	m_TestDlg[2].nLoopTest=GetProfileInt("Version 1.0","m_PortRegistry[2].nLoopTest",0);
	//m_TestDlg[2].nDisONOFF=GetProfileInt("Version 1.0","m_PortRegistry[2].nDisONOFF",0);
	m_TestDlg[2].nDisONOFF=m_structPortSettingsDlg[2].nPortOpen;
	m_itoaRegistry[2].strHrTime=GetProfileInt("Version 1.0","m_PortRegistry[2].strHrTime",3);
	m_itoaRegistry[2].strMinTime=GetProfileInt("Version 1.0","m_PortRegistry[2].strMinTime",30);

	if(m_TransferDataDlg[2].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
	{                                 //and not file
		m_TransferDataDlg[2].nFile=0;
		m_TransferDataDlg[2].nAlpha=1;
	}

	itoa(m_itoaRegistry[2].strHrTime,cHrTime,10);
	m_TestDlg[2].strHrTime=cHrTime;
	itoa(m_itoaRegistry[2].strMinTime,cMinTime,10);
	m_TestDlg[2].strMinTime=cMinTime;

	m_TransferDataDlg[2].strUser="Hello World\r\n";
	m_TestDlg[2].strTx="";
	m_TestDlg[2].strRx="";	

	m_structPortSettingsDlg[3].nPortOpen=GetProfileInt("Version 1.0","m_PortRegistry[3].nPortOpen",0);
	m_structPortSettingsDlg[3].nBaud= GetProfileInt("Version 1.0","m_PortRegistry[3].nBaud",13);
	m_structPortSettingsDlg[3].nDataBits=GetProfileInt("Version 1.0","m_PortRegistry[3].nDataBits",3);
	m_structPortSettingsDlg[3].nParity=GetProfileInt("Version 1.0","m_PortRegistry[3].nParity",4);
	m_structPortSettingsDlg[3].nStopBits=GetProfileInt("Version 1.0","m_PortRegistry[3].nStopBits",0);
	m_structPortSettingsDlg[3].nFlowCtrl=GetProfileInt("Version 1.0","m_PortRegistry[3].nFlowCtrl",2);
	m_structPortSettingsDlg[3].nComBase=GetProfileInt("Version 1.0","m_PortRegistry[3].nComBase",7);
	m_structPortSettingsDlg[3].nRS485=GetProfileInt("Version 1.0","m_PortRegistry[3].nRS485",0);
	m_structPortSettingsDlg[3].nIR=GetProfileInt("Version 1.0","m_PortRegistry[3].nIR",0);
	m_structPortSettingsDlg[3].nDTR=GetProfileInt("Version 1.0","m_PortRegistry[3].nDTR",0);
	m_structPortSettingsDlg[3].nDTRHys=GetProfileInt("Version 1.0","m_PortRegistry[3].nDTRHys",3);
	m_structPortSettingsDlg[3].nRTS=GetProfileInt("Version 1.0","m_PortRegistry[3].nRTS",1);
	m_structPortSettingsDlg[3].nRTSHys=GetProfileInt("Version 1.0","m_PortRegistry[3].nRTSHys",3);	
	m_structPortSettingsDlg[3].nTxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[3].nTxFIFO",0);
	m_structPortSettingsDlg[3].nTxTrig=GetProfileInt("Version 1.0","m_PortRegistry[3].nTxTrig",0);
	m_structPortSettingsDlg[3].nRxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[3].nRxFIFO",0);		
	m_structPortSettingsDlg[3].nRxTrig=GetProfileInt("Version 1.0","m_PortRegistry[3].nRxTrig",31);
	m_TransferDataDlg[3].nQuickBrown=GetProfileInt("Version 1.0","m_PortRegistry[3].nQuickBrown",0);
	m_TransferDataDlg[3].nAlpha=GetProfileInt("Version 1.0","m_PortRegistry[3].nAlpha",1);
	m_TransferDataDlg[3].nFile=GetProfileInt("Version 1.0","m_PortRegistry[3].nFile",0);
	m_TransferDataDlg[3].nUserData=GetProfileInt("Version 1.0","m_PortRegistry[3].nUserData",0);
	m_TestDlg[3].nTestForever=GetProfileInt("Version 1.0","m_PortRegistry[3].nTestForever",1);
	m_TestDlg[3].nStopTime=GetProfileInt("Version 1.0","m_PortRegistry[3].nStopTime",0);
	m_TestDlg[3].nStopError=GetProfileInt("Version 1.0","m_PortRegistry[3].nStopError",0);
	m_TestDlg[3].nLoopTest=GetProfileInt("Version 1.0","m_PortRegistry[3].nLoopTest",0);
	//m_TestDlg[3].nDisONOFF=GetProfileInt("Version 1.0","m_PortRegistry[3].nDisONOFF",0);
	m_TestDlg[3].nDisONOFF=m_structPortSettingsDlg[3].nPortOpen;
	m_itoaRegistry[3].strHrTime=GetProfileInt("Version 1.0","m_PortRegistry[3].strHrTime",4);
	m_itoaRegistry[3].strMinTime=GetProfileInt("Version 1.0","m_PortRegistry[3].strMinTime",40);

	if(m_TransferDataDlg[3].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
	{                                 //and not file
		m_TransferDataDlg[3].nFile=0;
		m_TransferDataDlg[3].nAlpha=1;
	}

	itoa(m_itoaRegistry[3].strHrTime,cHrTime,10);
	m_TestDlg[3].strHrTime=cHrTime;
	itoa(m_itoaRegistry[3].strMinTime,cMinTime,10);
	m_TestDlg[3].strMinTime=cMinTime;

	m_TransferDataDlg[3].strUser="Try,try and try until you succeed\r\n";
	m_TestDlg[3].strTx="";
	m_TestDlg[3].strRx="";
	
	m_structPortSettingsDlg[4].nPortOpen=GetProfileInt("Version 1.0","m_PortRegistry[4].nPortOpen",0);
	m_structPortSettingsDlg[4].nBaud= GetProfileInt("Version 1.0","m_PortRegistry[4].nBaud",13);
	m_structPortSettingsDlg[4].nDataBits=GetProfileInt("Version 1.0","m_PortRegistry[4].nDataBits",3);
	m_structPortSettingsDlg[4].nParity=GetProfileInt("Version 1.0","m_PortRegistry[4].nParity",4);
	m_structPortSettingsDlg[4].nStopBits=GetProfileInt("Version 1.0","m_PortRegistry[4].nStopBits",0);
	m_structPortSettingsDlg[4].nFlowCtrl=GetProfileInt("Version 1.0","m_PortRegistry[4].nFlowCtrl",2);
	m_structPortSettingsDlg[4].nComBase=GetProfileInt("Version 1.0","m_PortRegistry[4].nComBase",8);
	m_structPortSettingsDlg[4].nRS485=GetProfileInt("Version 1.0","m_PortRegistry[4].nRS485",0);
	m_structPortSettingsDlg[4].nIR=GetProfileInt("Version 1.0","m_PortRegistry[4].nIR",0);
	m_structPortSettingsDlg[4].nDTR=GetProfileInt("Version 1.0","m_PortRegistry[4].nDTR",0);
	m_structPortSettingsDlg[4].nDTRHys=GetProfileInt("Version 1.0","m_PortRegistry[4].nDTRHys",3);
	m_structPortSettingsDlg[4].nRTS=GetProfileInt("Version 1.0","m_PortRegistry[4].nRTS",1);
	m_structPortSettingsDlg[4].nRTSHys=GetProfileInt("Version 1.0","m_PortRegistry[4].nRTSHys",3);	
	m_structPortSettingsDlg[4].nTxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[4].nTxFIFO",0);
	m_structPortSettingsDlg[4].nTxTrig=GetProfileInt("Version 1.0","m_PortRegistry[4].nTxTrig",0);
	m_structPortSettingsDlg[4].nRxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[4].nRxFIFO",0);		
	m_structPortSettingsDlg[4].nRxTrig=GetProfileInt("Version 1.0","m_PortRegistry[4].nRxTrig",31);
	m_TransferDataDlg[4].nQuickBrown=GetProfileInt("Version 1.0","m_PortRegistry[4].nQuickBrown",0);
	m_TransferDataDlg[4].nAlpha=GetProfileInt("Version 1.0","m_PortRegistry[4].nAlpha",1);
	m_TransferDataDlg[4].nFile=GetProfileInt("Version 1.0","m_PortRegistry[4].nFile",0);
	m_TransferDataDlg[4].nUserData=GetProfileInt("Version 1.0","m_PortRegistry[4].nUserData",0);
	m_TestDlg[4].nTestForever=GetProfileInt("Version 1.0","m_PortRegistry[4].nTestForever",0);
	m_TestDlg[4].nStopTime=GetProfileInt("Version 1.0","m_PortRegistry[4].nStopTime",0);
	m_TestDlg[4].nStopError=GetProfileInt("Version 1.0","m_PortRegistry[4].nStopError",1);
	m_TestDlg[4].nLoopTest=GetProfileInt("Version 1.0","m_PortRegistry[4].nLoopTest",0);
	//m_TestDlg[4].nDisONOFF=GetProfileInt("Version 1.0","m_PortRegistry[4].nDisONOFF",1);
	m_TestDlg[4].nDisONOFF=m_structPortSettingsDlg[4].nPortOpen;
	m_itoaRegistry[4].strHrTime=GetProfileInt("Version 1.0","m_PortRegistry[4].strHrTime",5);
	m_itoaRegistry[4].strMinTime=GetProfileInt("Version 1.0","m_PortRegistry[4].strMinTime",50);

	if(m_TransferDataDlg[4].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
	{                                 //and not file
		m_TransferDataDlg[4].nFile=0;
		m_TransferDataDlg[4].nAlpha=1;
	}

	itoa(m_itoaRegistry[4].strHrTime,cHrTime,10);
	m_TestDlg[4].strHrTime=cHrTime;
	itoa(m_itoaRegistry[4].strMinTime,cMinTime,10);
	m_TestDlg[4].strMinTime=cMinTime;

	
	m_TransferDataDlg[4].strUser="Octal Serial Port Driver User Interface\r\n";
	m_TestDlg[4].strTx="";
	m_TestDlg[4].strRx="";
	
	m_structPortSettingsDlg[5].nPortOpen=GetProfileInt("Version 1.0","m_PortRegistry[5].nPortOpen",0);
	m_structPortSettingsDlg[5].nBaud= GetProfileInt("Version 1.0","m_PortRegistry[5].nBaud",13);
	m_structPortSettingsDlg[5].nDataBits=GetProfileInt("Version 1.0","m_PortRegistry[5].nDataBits",3);
	m_structPortSettingsDlg[5].nParity=GetProfileInt("Version 1.0","m_PortRegistry[5].nParity",4);
	m_structPortSettingsDlg[5].nStopBits=GetProfileInt("Version 1.0","m_PortRegistry[5].nStopBits",0);
	m_structPortSettingsDlg[5].nFlowCtrl=GetProfileInt("Version 1.0","m_PortRegistry[5].nFlowCtrl",2);
	m_structPortSettingsDlg[5].nComBase=GetProfileInt("Version 1.0","m_PortRegistry[5].nComBase",9);
	m_structPortSettingsDlg[5].nRS485=GetProfileInt("Version 1.0","m_PortRegistry[5].nRS485",0);
	m_structPortSettingsDlg[5].nIR=GetProfileInt("Version 1.0","m_PortRegistry[5].nIR",0);
	m_structPortSettingsDlg[5].nDTR=GetProfileInt("Version 1.0","m_PortRegistry[5].nDTR",0);
	m_structPortSettingsDlg[5].nDTRHys=GetProfileInt("Version 1.0","m_PortRegistry[5].nDTRHys",3);
	m_structPortSettingsDlg[5].nRTS=GetProfileInt("Version 1.0","m_PortRegistry[5].nRTS",1);
	m_structPortSettingsDlg[5].nRTSHys=GetProfileInt("Version 1.0","m_PortRegistry[5].nRTSHys",3);	
	m_structPortSettingsDlg[5].nTxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[5].nTxFIFO",0);
	m_structPortSettingsDlg[5].nTxTrig=GetProfileInt("Version 1.0","m_PortRegistry[5].nTxTrig",0);
	m_structPortSettingsDlg[5].nRxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[5].nRxFIFO",0);		
	m_structPortSettingsDlg[5].nRxTrig=GetProfileInt("Version 1.0","m_PortRegistry[5].nRxTrig",31);
	m_TransferDataDlg[5].nQuickBrown=GetProfileInt("Version 1.0","m_PortRegistry[5].nQuickBrown",0);
	m_TransferDataDlg[5].nAlpha=GetProfileInt("Version 1.0","m_PortRegistry[5].nAlpha",1);
	m_TransferDataDlg[5].nFile=GetProfileInt("Version 1.0","m_PortRegistry[5].nFile",0);
	m_TransferDataDlg[5].nUserData=GetProfileInt("Version 1.0","m_PortRegistry[5].nUserData",0);
	m_TestDlg[5].nTestForever=GetProfileInt("Version 1.0","m_PortRegistry[5].nTestForever",1);
	m_TestDlg[5].nStopTime=GetProfileInt("Version 1.0","m_PortRegistry[5].nStopTime",0);
	m_TestDlg[5].nStopError=GetProfileInt("Version 1.0","m_PortRegistry[5].nStopError",0);
	m_TestDlg[5].nLoopTest=GetProfileInt("Version 1.0","m_PortRegistry[5].nLoopTest",0);
	//m_TestDlg[5].nDisONOFF=GetProfileInt("Version 1.0","m_PortRegistry[5].nDisONOFF",1);
	m_TestDlg[5].nDisONOFF=m_structPortSettingsDlg[5].nPortOpen;
	m_itoaRegistry[5].strHrTime=GetProfileInt("Version 1.0","m_PortRegistry[5].strHrTime",6);
	m_itoaRegistry[5].strMinTime=GetProfileInt("Version 1.0","m_PortRegistry[5].strMinTime",60);

	if(m_TransferDataDlg[5].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
	{                                 //and not file
		m_TransferDataDlg[5].nFile=0;
		m_TransferDataDlg[5].nAlpha=1;
	}

	itoa(m_itoaRegistry[5].strHrTime,cHrTime,10);
	m_TestDlg[5].strHrTime=cHrTime;
	itoa(m_itoaRegistry[5].strMinTime,cMinTime,10);
	m_TestDlg[5].strMinTime=cMinTime;

	m_TransferDataDlg[5].strUser="Exar Corporation\r\n";
	m_TestDlg[5].strTx="";
	m_TestDlg[5].strRx="";	

	m_structPortSettingsDlg[6].nPortOpen=GetProfileInt("Version 1.0","m_PortRegistry[6].nPortOpen",0);
	m_structPortSettingsDlg[6].nBaud= GetProfileInt("Version 1.0","m_PortRegistry[6].nBaud",13);
	m_structPortSettingsDlg[6].nDataBits=GetProfileInt("Version 1.0","m_PortRegistry[6].nDataBits",3);
	m_structPortSettingsDlg[6].nParity=GetProfileInt("Version 1.0","m_PortRegistry[6].nParity",4);
	m_structPortSettingsDlg[6].nStopBits=GetProfileInt("Version 1.0","m_PortRegistry[6].nStopBits",0);
	m_structPortSettingsDlg[6].nFlowCtrl=GetProfileInt("Version 1.0","m_PortRegistry[6].nFlowCtrl",2);
	m_structPortSettingsDlg[6].nComBase=GetProfileInt("Version 1.0","m_PortRegistry[6].nComBase",10);
	m_structPortSettingsDlg[6].nRS485=GetProfileInt("Version 1.0","m_PortRegistry[6].nRS485",0);
	m_structPortSettingsDlg[6].nIR=GetProfileInt("Version 1.0","m_PortRegistry[6].nIR",0);
	m_structPortSettingsDlg[6].nDTR=GetProfileInt("Version 1.0","m_PortRegistry[6].nDTR",0);
	m_structPortSettingsDlg[6].nDTRHys=GetProfileInt("Version 1.0","m_PortRegistry[6].nDTRHys",3);
	m_structPortSettingsDlg[6].nRTS=GetProfileInt("Version 1.0","m_PortRegistry[6].nRTS",1);
	m_structPortSettingsDlg[6].nRTSHys=GetProfileInt("Version 1.0","m_PortRegistry[6].nRTSHys",3);	
	m_structPortSettingsDlg[6].nTxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[6].nTxFIFO",0);
	m_structPortSettingsDlg[6].nTxTrig=GetProfileInt("Version 1.0","m_PortRegistry[6].nTxTrig",0);
	m_structPortSettingsDlg[6].nRxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[6].nRxFIFO",0);		
	m_structPortSettingsDlg[6].nRxTrig=GetProfileInt("Version 1.0","m_PortRegistry[6].nRxTrig",31);
	m_TransferDataDlg[6].nQuickBrown=GetProfileInt("Version 1.0","m_PortRegistry[6].nQuickBrown",0);
	m_TransferDataDlg[6].nAlpha=GetProfileInt("Version 1.0","m_PortRegistry[6].nAlpha",1);
	m_TransferDataDlg[6].nFile=GetProfileInt("Version 1.0","m_PortRegistry[6].nFile",0);
	m_TransferDataDlg[6].nUserData=GetProfileInt("Version 1.0","m_PortRegistry[6].nUserData",0);
	m_TestDlg[6].nTestForever=GetProfileInt("Version 1.0","m_PortRegistry[6].nTestForever",1);
	m_TestDlg[6].nStopTime=GetProfileInt("Version 1.0","m_PortRegistry[6].nStopTime",0);
	m_TestDlg[6].nStopError=GetProfileInt("Version 1.0","m_PortRegistry[6].nStopError",0);
	m_TestDlg[6].nLoopTest=GetProfileInt("Version 1.0","m_PortRegistry[6].nLoopTest",0);
	//m_TestDlg[6].nDisONOFF=GetProfileInt("Version 1.0","m_PortRegistry[6].nDisONOFF",1);
	m_TestDlg[6].nDisONOFF=m_structPortSettingsDlg[6].nPortOpen;
	m_itoaRegistry[6].strHrTime=GetProfileInt("Version 1.0","m_PortRegistry[6].strHrTime",7);
	m_itoaRegistry[6].strMinTime=GetProfileInt("Version 1.0","m_PortRegistry[6].strMinTime",17);

	if(m_TransferDataDlg[6].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
	{                                 //and not file
		m_TransferDataDlg[6].nFile=0;
		m_TransferDataDlg[6].nAlpha=1;
	}

	itoa(m_itoaRegistry[6].strHrTime,cHrTime,10);
	m_TestDlg[6].strHrTime=cHrTime;
	itoa(m_itoaRegistry[6].strMinTime,cMinTime,10);
	m_TestDlg[6].strMinTime=cMinTime;

	m_TransferDataDlg[6].strUser="Exar Corporation\r\n";
	m_TestDlg[6].strTx="";
	m_TestDlg[6].strRx="";	

	m_structPortSettingsDlg[7].nPortOpen=GetProfileInt("Version 1.0","m_PortRegistry[7].nPortOpen",0);
	m_structPortSettingsDlg[7].nBaud= GetProfileInt("Version 1.0","m_PortRegistry[7].nBaud",13);
	m_structPortSettingsDlg[7].nDataBits=GetProfileInt("Version 1.0","m_PortRegistry[7].nDataBits",3);
	m_structPortSettingsDlg[7].nParity=GetProfileInt("Version 1.0","m_PortRegistry[7].nParity",4);
	m_structPortSettingsDlg[7].nStopBits=GetProfileInt("Version 1.0","m_PortRegistry[7].nStopBits",0);
	m_structPortSettingsDlg[7].nFlowCtrl=GetProfileInt("Version 1.0","m_PortRegistry[7].nFlowCtrl",2);
	m_structPortSettingsDlg[7].nComBase=GetProfileInt("Version 1.0","m_PortRegistry[7].nComBase",11);
	m_structPortSettingsDlg[7].nRS485=GetProfileInt("Version 1.0","m_PortRegistry[7].nRS485",0);
	m_structPortSettingsDlg[7].nIR=GetProfileInt("Version 1.0","m_PortRegistry[7].nIR",0);
	m_structPortSettingsDlg[7].nDTR=GetProfileInt("Version 1.0","m_PortRegistry[7].nDTR",0);
	m_structPortSettingsDlg[7].nDTRHys=GetProfileInt("Version 1.0","m_PortRegistry[7].nDTRHys",3);
	m_structPortSettingsDlg[7].nRTS=GetProfileInt("Version 1.0","m_PortRegistry[7].nRTS",1);
	m_structPortSettingsDlg[7].nRTSHys=GetProfileInt("Version 1.0","m_PortRegistry[7].nRTSHys",3);	
	m_structPortSettingsDlg[7].nTxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[7].nTxFIFO",0);
	m_structPortSettingsDlg[7].nTxTrig=GetProfileInt("Version 1.0","m_PortRegistry[7].nTxTrig",0);
	m_structPortSettingsDlg[7].nRxFIFO=GetProfileInt("Version 1.0","m_PortRegistry[7].nRxFIFO",0);		
	m_structPortSettingsDlg[7].nRxTrig=GetProfileInt("Version 1.0","m_PortRegistry[7].nRxTrig",31);
	m_TransferDataDlg[7].nQuickBrown=GetProfileInt("Version 1.0","m_PortRegistry[7].nQuickBrown",0);
	m_TransferDataDlg[7].nAlpha=GetProfileInt("Version 1.0","m_PortRegistry[7].nAlpha",1);
	m_TransferDataDlg[7].nFile=GetProfileInt("Version 1.0","m_PortRegistry[7].nFile",0);
	m_TransferDataDlg[7].nUserData=GetProfileInt("Version 1.0","m_PortRegistry[7].nUserData",0);
	m_TestDlg[7].nTestForever=GetProfileInt("Version 1.0","m_PortRegistry[7].nTestForever",1);
	m_TestDlg[7].nStopTime=GetProfileInt("Version 1.0","m_PortRegistry[7].nStopTime",0);
	m_TestDlg[7].nStopError=GetProfileInt("Version 1.0","m_PortRegistry[7].nStopError",0);
	m_TestDlg[7].nLoopTest=GetProfileInt("Version 1.0","m_PortRegistry[7].nLoopTest",0);
	//m_TestDlg[7].nDisONOFF=GetProfileInt("Version 1.0","m_PortRegistry[7].nDisONOFF",1);
	m_TestDlg[7].nDisONOFF=m_structPortSettingsDlg[7].nPortOpen;
	m_itoaRegistry[7].strHrTime=GetProfileInt("Version 1.0","m_PortRegistry[7].strHrTime",8);
	m_itoaRegistry[7].strMinTime=GetProfileInt("Version 1.0","m_PortRegistry[7].strMinTime",18);

	if(m_TransferDataDlg[7].nFile)//if the user has selected file previously,
		                                  //next when you open select alpha
	{                                 //and not file
		m_TransferDataDlg[7].nFile=0;
		m_TransferDataDlg[7].nAlpha=1;
	}

	itoa(m_itoaRegistry[7].strHrTime,cHrTime,10);
	m_TestDlg[7].strHrTime=cHrTime;
	itoa(m_itoaRegistry[7].strMinTime,cMinTime,10);
	m_TestDlg[7].strMinTime=cMinTime;

	m_TransferDataDlg[7].strUser="Exar Corporation\r\n";
	m_TestDlg[7].strTx="";
	m_TestDlg[7].strRx="";

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CSerial758UIApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CSerial758UIApp commands


void CSerial758UIApp::OnTestStart() 
{
	//Here we are creating a modeless dialog using create() function.
	CString StrdlgError,strPorterror;
	StrdlgError = "Unable to create the Serial Communication Test Dialog";

	m_structPort.hThreadExit = CreateEvent(NULL,FALSE,FALSE,NULL);
	if(m_structPort.hThreadExit == NULL)
		AfxGetMainWnd()->MessageBox("Unable to create the ThreadExitEvent handle","Error",MB_OK|MB_ICONEXCLAMATION);

	
	//m_pMainWnd->m_nThreadCount=0;//initialize
	m_structPort.nPortOpenCount=0;//initialize the count of successfully open ports
	
	OnPortCreation();//function which opens the required ports
	
	if(!m_structPort.bOnePortFlag)//none of the comm port was open
	{
		strPorterror.Format("Unable to open any communication port");
		AfxGetMainWnd()->MessageBox(strPorterror,"ERROR",MB_OK|MB_ICONEXCLAMATION);
		
		//update the menu items as required
		m_bTestStart = TRUE;
		m_bTestStop = FALSE;
		m_bSetUp = TRUE;
		m_bSetUpCustomClock = TRUE;
	}
	else//at least one port was open so continue
	{
		//update all the menu items 
		m_bTestStart=FALSE;//disable the TestStart Menu item
		m_bTestStop=TRUE;
		m_bSetUp = FALSE;//once the user has said start disable the port configuration dialog menu item
		m_bSetUpCustomClock = FALSE;
		
		if(m_pSerialCommTestDlg != NULL)//if the modeless dialog is already displayed 
			//then setfocus on to it else create the dialog
			m_pSerialCommTestDlg->SetFocus();
		else
		{			
			m_pSerialCommTestDlg = new CSerialCommTestDlg;//declare a object
			BOOL nRet=m_pSerialCommTestDlg->Create(IDD_SERIALTEST);// creating the modeless dialog box
			//if a port was opened successfully, then create 2 threads one for writing and
			if(!nRet) // if the function fails
			{
				AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);
				return;
			}
		}
		
		//one for reading
		m_structPort.bThreadContinue = TRUE;//parameter passed to threads
		m_nRunCount=0;
		
		/////////////////////new//////////////////////

		//create 8 write  events for eight ports .Only one write thread is created
		for(int k=0;k<MAXPORTS;k++)
			m_WriteThreadInfo.hPortHandle[k] = m_structPort.hPortHandle[k];
				

		//create a write thread
		m_structPort.hWrite = CreateEvent(NULL,FALSE,FALSE,NULL);
		if(m_structPort.hWrite == NULL)
				AfxGetMainWnd()->MessageBox("Unable to create the Write Event handle","Error",MB_OK|MB_ICONEXCLAMATION);

		m_WriteThreadInfo.nIndex = k;//represents the array number.has incorrect value not used right now
		m_WriteThreadInfo.bContinueFlag = &m_structPort.bThreadContinue;
		m_WriteThreadInfo.hNotifyUpdate = AfxGetMainWnd()->m_hWnd;
		m_WriteThreadInfo.hThreadExit = m_structPort.hThreadExit;
		//m_WriteThreadInfo.nBytes = &m_WriteThreadParam[m].nWriteBytes;
		//m_WriteThreadInfo.pWriteArray = m_WriteThreadParam[m].WriteBuff;
		m_WriteThreadInfo.hWrite = m_structPort.hWrite;

		m_structPort.pWriteThread = AfxBeginThread(WriteCommFunc,&m_WriteThreadInfo, THREAD_PRIORITY_LOWEST);
							
		//////////////////////new/////////////////////

		
		for(int m=0;m<MAXPORTS;m++)
		{
			if(m_structPort.bPortOpenFlag[m])//if port is opened successfully
			{
				//create the write and thread exit events
				//m_structPort.hWrite = CreateEvent(NULL,FALSE,FALSE,NULL);
				//if(m_structPort.hWrite == NULL)
					//AfxGetMainWnd()->MessageBox("Unable to create the WriteEvent handle","Error",MB_OK|MB_ICONEXCLAMATION);
				
				
				/*//create a write thread
				m_WriteThreadInfo[m].bContinueFlag = &m_structPort.bThreadContinue;
				m_WriteThreadInfo[m].hPortHandle = m_structPort.hPortHandle[m];
				m_WriteThreadInfo[m].nIndex = m;//represents the array number
				m_WriteThreadInfo[m].hNotifyUpdate = AfxGetMainWnd()->m_hWnd;
				m_WriteThreadInfo[m].hWrite=m_WriteThreadParam[m].hWrite;
				m_WriteThreadInfo[m].hThreadExit=m_structPort.hThreadExit;
				m_WriteThreadInfo[m].nBytes = &m_WriteThreadParam[m].nWriteBytes;
				m_WriteThreadInfo[m].pWriteArray = m_WriteThreadParam[m].WriteBuff;
				m_WriteThreadParam[m].pWriteThread = AfxBeginThread(WriteCommFunc,&m_WriteThreadInfo[m]);*/
							
				//create a read thread
				m_ReadThreadInfo[m].bContinueFlag = &m_structPort.bThreadContinue;
				m_ReadThreadInfo[m].hPortHandle = m_structPort.hPortHandle[m];
				m_ReadThreadInfo[m].nIndex = m;//represents the array number
				m_ReadThreadInfo[m].hNotifyUpdate = AfxGetMainWnd()->m_hWnd;
				m_ReadThreadInfo[m].nBytes = &m_ReadThreadParam[m].nReadBytes;
				m_ReadThreadInfo[m].pReadArray = m_ReadThreadParam[m].ReadBuff;
				m_ReadThreadParam[m].pReadThread = AfxBeginThread(ReadStatusCommFunc,&m_ReadThreadInfo[m]);
				
				//m_PortTest.On_OpenPorts(m);
			}
		}//end of for loop
		
		int nleft,nright,nbottom,ntop;
		//fit the serial test dialog into the main window
		
		nbottom=580;
		nright=860;
		ntop=100;
		nleft=100;
		
		m_pSerialCommTestDlg->SetWindowPos(NULL,nleft,ntop,nright,nbottom,SWP_SHOWWINDOW);
		
		m_PortTest.On_TestStart();		
	}	
}


void CSerial758UIApp::OnConfigLoad() 
{
	//This function lets the user to load the configuration from a file for the ports 
	FILE *LoadFile;
	char temp[10];//dummy variable

	char szFilters[]="Text files (*.txt)|*.txt|All files (*.*)|*.*||";
	CFileDialog dlg(TRUE,"txt","*.txt",OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,szFilters);

	if(dlg.DoModal() == IDOK)
	{
		CString filename=dlg.GetFileName();
	   LoadFile = fopen( filename, "r" );
		if( LoadFile == NULL )
			 AfxGetMainWnd()->MessageBox("Unable to Load the file","Error",MB_OK|MB_ICONEXCLAMATION);
		else
		{
           //Set pointer to beginning of file 
			fseek( LoadFile, 0L, SEEK_SET );
			
			for(int u=0;u<MAXPORTS;u++)//load the values from the specified file into the 
				                       //corresponding variables for further use
			{
				int nRet=fscanf(LoadFile,"%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",temp,\
					   &m_structPortSettingsDlg[u].nBaud,&m_structPortSettingsDlg[u].nDataBits,\
					   &m_structPortSettingsDlg[u].nParity,&m_structPortSettingsDlg[u].nStopBits,\
					   &m_structPortSettingsDlg[u].nFlowCtrl,&m_structPortSettingsDlg[u].nComBase,\
					   &m_structPortSettingsDlg[u].nRS485,\
					   &m_structPortSettingsDlg[u].nIR,\
				       &m_structPortSettingsDlg[u].nDTR,&m_structPortSettingsDlg[u].nDTRHys,\
					   &m_structPortSettingsDlg[u].nRTS,&m_structPortSettingsDlg[u].nRTSHys,\
					   &m_structPortSettingsDlg[u].nTxFIFO,&m_structPortSettingsDlg[u].nTxTrig,\
					   &m_structPortSettingsDlg[u].nRxFIFO,&m_structPortSettingsDlg[u].nRxTrig);// Read data back from file

				if(nRet == EOF)
				{
					AfxGetMainWnd()->MessageBox("Unable to read from the file","Error",MB_OK|MB_ICONEXCLAMATION);
					return;
				}
				
				if(u)//if it is not for the first port
					m_structPortSettingsDlg[u].nComBase=m_structPortSettingsDlg[0].nComBase+u;
			}
		   
			fclose(LoadFile);
		}

	}//end of IDOK
}

void CSerial758UIApp::OnConfigSave() 
{
	//This function lets the user to save the configuration to a file for the ports 

	FILE *SaveFile;
	CString strName;

	unsigned char temp[8];
	
	char szFilters[]="Text files (*.txt)|*.txt|All files (*.*)|*.*||";
	CFileDialog dlg(FALSE,"txt","*.txt",OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,szFilters);

	if(dlg.DoModal() == IDOK)
	{
	   CString filename=dlg.GetFileName();
	   SaveFile = fopen( filename, "w" );
		if( SaveFile == NULL )
			 AfxGetMainWnd()->MessageBox("Unable to Load the file","Error",MB_OK|MB_ICONEXCLAMATION);
		else
		{
           //Set pointer to beginning of file 
			fseek( SaveFile, 0L, SEEK_SET );
			
			for(int u=0;u<MAXPORTS;u++)
			{
				strName.Format("SERIAL%d:",u);
				for(int i=0;i<(strName.GetLength()-1);i++)
					temp[i]=strName.GetAt(i);
				temp[i]=NULL;

				int nRet=fprintf(SaveFile,"%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",temp,\
					   m_structPortSettingsDlg[u].nBaud,m_structPortSettingsDlg[u].nDataBits,\
					   m_structPortSettingsDlg[u].nParity,m_structPortSettingsDlg[u].nStopBits,\
					   m_structPortSettingsDlg[u].nFlowCtrl,m_structPortSettingsDlg[u].nComBase,\
					   m_structPortSettingsDlg[u].nRS485,\
					   m_structPortSettingsDlg[u].nIR,\
				       m_structPortSettingsDlg[u].nDTR,m_structPortSettingsDlg[u].nDTRHys,\
					   m_structPortSettingsDlg[u].nRTS,m_structPortSettingsDlg[u].nRTSHys,\
					   m_structPortSettingsDlg[u].nTxFIFO,m_structPortSettingsDlg[u].nTxTrig,\
					   m_structPortSettingsDlg[u].nRxFIFO,m_structPortSettingsDlg[u].nRxTrig);// Read data back from file

				if(nRet == EOF)
				{
					AfxGetMainWnd()->MessageBox("Unable to read from the file","Error",MB_OK|MB_ICONEXCLAMATION);
					return;
				}			
			}//end of for loop
		   
			fclose(SaveFile);
		}

	}//end of IDOK
	
}

void CSerial758UIApp::OnTestStop() 
{
	//this function sets the commmask to zero in order to release any waiting thread
	//and sets the bThreadContinue flag to FALSE to end the thread function.

	m_structPort.bThreadContinue=FALSE;//kill the read and write threads
	SetEvent(m_structPort.hThreadExit);
	
	for(int m=0;m<MAXPORTS;m++)	
	{
		if(m_structPort.bPortOpenFlag[m])//if port is opened successfully
		{
			//SetEvent(m_WriteThreadParam[m].hWriteDone);
			if(m_pSerialCommTestDlg != NULL)
			{
				m_PortTest.OnStop(m);
				//m_PortTest.On_ClosePorts(m);
			}
			
			SetCommMask(m_structPort.hPortHandle[m],0);//release the read thread if waiting
			
		}		
		m_structErrChecking[m].ntempReadBytes=0;//initialize 
		m_structErrChecking[m].bInCompleteRead=FALSE;//initialize
		m_structErrChecking[m].bFilePending=FALSE;//initialize 
	}

	m_structPort.bThreadContinue=FALSE;//kill the read and write threads
}

void CSerial758UIApp::OnPortCreation()
{
	//In this function the MAXPORTS(no of comm ports) are opened by calling CreatePort member function. If at
	//least one port was opened successfully then the bPortErrFlag will be set and the handles of all
	//the ports opened successfully will be placed in an array of handles
	
	CString strerror = " Unable to open the Port .\n\rPort may be used by another Application.Please Check";
	
	m_structPort.bOnePortFlag=0;//initial value

	for(int m=0;m<MAXPORTS;m++)	
	{
		m_structPort.hPortHandle[m]=NULL;//initialize
		if(m_structPortSettingsDlg[m].nPortOpen)//if user wants to open the port then do so
		{			
			m_structPort.bPortOpenFlag[m]=0;//initially no ports are open
			//m_structPortSettingsDlg[m].nComBase=m_structPortSettingsDlg[0].nComBase+m;//already taken care at the dialog member function onselectionchange...//combase of the port 1 is taken as a base for other ports
			m_structPort.hPortHandle[m]=m_structPort.Port.CreatePort((m_structPortSettingsDlg[m].nComBase+1));
	
			if(m_structPort.hPortHandle[m]==NULL)
			{
				strerror.Format("Unable to open the communication port COM%d",m_structPortSettingsDlg[m].nComBase+1);
				AfxGetMainWnd()->MessageBox(strerror,"ERROR",MB_OK|MB_ICONEXCLAMATION);
			}
			else
			{
				m_structPort.nPortOpenCount++;
				m_structPort.bPortOpenFlag[m]=1;//set the flag for the port represented by m to 1 to indicate that the port was opened successfully
				m_structPort.bOnePortFlag=1;//indicates that the port represented by m was opened successfully
			}
		}
	}
}

int CSerial758UIApp::ExitInstance() 
{
	//this function is called by the framework when the application is exited. The variables
	//are copied into the registry before quiting

	m_itoaRegistry[0].strHrTime=atoi(m_TestDlg[0].strHrTime);
	m_itoaRegistry[0].strMinTime=atoi(m_TestDlg[0].strMinTime);

	WriteProfileInt("Version 1.0","m_PortRegistry[0].nPortOpen",m_structPortSettingsDlg[0].nPortOpen);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nBaud",m_structPortSettingsDlg[0].nBaud);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nDataBits",m_structPortSettingsDlg[0].nDataBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nParity",m_structPortSettingsDlg[0].nParity);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nStopBits",m_structPortSettingsDlg[0].nStopBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nFlowCtrl",m_structPortSettingsDlg[0].nFlowCtrl);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nComBase",m_structPortSettingsDlg[0].nComBase);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nRS485",m_structPortSettingsDlg[0].nRS485);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nIR",m_structPortSettingsDlg[0].nIR);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nDTR",m_structPortSettingsDlg[0].nDTR);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nDTRHys",m_structPortSettingsDlg[0].nDTRHys);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nRTS",m_structPortSettingsDlg[0].nRTS);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nRTSHys",m_structPortSettingsDlg[0].nRTSHys);	
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nTxFIFO",m_structPortSettingsDlg[0].nTxFIFO);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nTxTrig",m_structPortSettingsDlg[0].nTxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nRxFIFO",m_structPortSettingsDlg[0].nRxFIFO);		
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nRxTrig",m_structPortSettingsDlg[0].nRxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nQuickBrown",m_TransferDataDlg[0].nQuickBrown);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nAlpha",m_TransferDataDlg[0].nAlpha);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nFile",m_TransferDataDlg[0].nFile);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nUserData",m_TransferDataDlg[0].nUserData);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nTestForever",m_TestDlg[0].nTestForever);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nStopTime",m_TestDlg[0].nStopTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nStopError",m_TestDlg[0].nStopError);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nLoopTest",m_TestDlg[0].nLoopTest);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].nDisONOFF",m_TestDlg[0].nDisONOFF);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].strHrTime",m_itoaRegistry[0].strHrTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[0].strMinTime",m_itoaRegistry[0].strMinTime);

	m_itoaRegistry[1].strHrTime=atoi(m_TestDlg[1].strHrTime);
	m_itoaRegistry[1].strMinTime=atoi(m_TestDlg[1].strMinTime);

	WriteProfileInt("Version 1.0","m_PortRegistry[1].nPortOpen",m_structPortSettingsDlg[1].nPortOpen);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nBaud",m_structPortSettingsDlg[1].nBaud);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nDataBits",m_structPortSettingsDlg[1].nDataBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nParity",m_structPortSettingsDlg[1].nParity);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nStopBits",m_structPortSettingsDlg[1].nStopBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nFlowCtrl",m_structPortSettingsDlg[1].nFlowCtrl);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nComBase",m_structPortSettingsDlg[1].nComBase);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nRS485",m_structPortSettingsDlg[1].nRS485);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nIR",m_structPortSettingsDlg[1].nIR);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nDTR",m_structPortSettingsDlg[1].nDTR);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nDTRHys",m_structPortSettingsDlg[1].nDTRHys);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nRTS",m_structPortSettingsDlg[1].nRTS);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nRTSHys",m_structPortSettingsDlg[1].nRTSHys);	
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nTxFIFO",m_structPortSettingsDlg[1].nTxFIFO);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nTxTrig",m_structPortSettingsDlg[1].nTxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nRxFIFO",m_structPortSettingsDlg[1].nRxFIFO);		
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nRxTrig",m_structPortSettingsDlg[1].nRxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nQuickBrown",m_TransferDataDlg[1].nQuickBrown);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nAlpha",m_TransferDataDlg[1].nAlpha);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nFile",m_TransferDataDlg[1].nFile);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nUserData",m_TransferDataDlg[1].nUserData);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nTestForever",m_TestDlg[1].nTestForever);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nStopTime",m_TestDlg[1].nStopTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nStopError",m_TestDlg[1].nStopError);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nLoopTest",m_TestDlg[1].nLoopTest);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].nDisONOFF",m_TestDlg[1].nDisONOFF);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].strHrTime",m_itoaRegistry[1].strHrTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[1].strMinTime",m_itoaRegistry[1].strMinTime);

	m_itoaRegistry[2].strHrTime=atoi(m_TestDlg[2].strHrTime);
	m_itoaRegistry[2].strMinTime=atoi(m_TestDlg[2].strMinTime);

	WriteProfileInt("Version 1.0","m_PortRegistry[2].nPortOpen",m_structPortSettingsDlg[2].nPortOpen);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nBaud",m_structPortSettingsDlg[2].nBaud);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nDataBits",m_structPortSettingsDlg[2].nDataBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nParity",m_structPortSettingsDlg[2].nParity);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nStopBits",m_structPortSettingsDlg[2].nStopBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nFlowCtrl",m_structPortSettingsDlg[2].nFlowCtrl);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nComBase",m_structPortSettingsDlg[2].nComBase);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nRS485",m_structPortSettingsDlg[2].nRS485);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nIR",m_structPortSettingsDlg[2].nIR);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nDTR",m_structPortSettingsDlg[2].nDTR);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nDTRHys",m_structPortSettingsDlg[2].nDTRHys);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nRTS",m_structPortSettingsDlg[2].nRTS);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nRTSHys",m_structPortSettingsDlg[2].nRTSHys);	
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nTxFIFO",m_structPortSettingsDlg[2].nTxFIFO);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nTxTrig",m_structPortSettingsDlg[2].nTxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nRxFIFO ",m_structPortSettingsDlg[2].nRxFIFO);		
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nRxTrig",m_structPortSettingsDlg[2].nRxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nQuickBrown",m_TransferDataDlg[2].nQuickBrown);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nAlpha",m_TransferDataDlg[2].nAlpha);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nFile",m_TransferDataDlg[2].nFile);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nUserData",m_TransferDataDlg[2].nUserData);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nTestForever",m_TestDlg[2].nTestForever);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nStopTime",m_TestDlg[2].nStopTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nStopError",m_TestDlg[2].nStopError);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nLoopTest",m_TestDlg[2].nLoopTest);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].nDisONOFF",m_TestDlg[2].nDisONOFF);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].strHrTime",m_itoaRegistry[2].strHrTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[2].strMinTime",m_itoaRegistry[2].strMinTime);

	m_itoaRegistry[3].strHrTime=atoi(m_TestDlg[3].strHrTime);
	m_itoaRegistry[3].strMinTime=atoi(m_TestDlg[3].strMinTime);

	WriteProfileInt("Version 1.0","m_PortRegistry[3].nPortOpen",m_structPortSettingsDlg[3].nPortOpen);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nBaud",m_structPortSettingsDlg[3].nBaud);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nDataBits",m_structPortSettingsDlg[3].nDataBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nParity",m_structPortSettingsDlg[3].nParity);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nStopBits",m_structPortSettingsDlg[3].nStopBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nFlowCtrl",m_structPortSettingsDlg[3].nFlowCtrl);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nComBase",m_structPortSettingsDlg[3].nComBase);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nRS485",m_structPortSettingsDlg[3].nRS485);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nIR",m_structPortSettingsDlg[3].nIR);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nDTR",m_structPortSettingsDlg[3].nDTR);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nDTRHys",m_structPortSettingsDlg[3].nDTRHys);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nRTS",m_structPortSettingsDlg[3].nRTS);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nRTSHys",m_structPortSettingsDlg[3].nRTSHys);	
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nTxFIFO",m_structPortSettingsDlg[3].nTxFIFO);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nTxTrig",m_structPortSettingsDlg[3].nTxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nRxFIFO",m_structPortSettingsDlg[3].nRxFIFO);		
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nRxTrig",m_structPortSettingsDlg[3].nRxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nQuickBrown",m_TransferDataDlg[3].nQuickBrown);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nAlpha",m_TransferDataDlg[3].nAlpha);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nFile",m_TransferDataDlg[3].nFile);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nUserData",m_TransferDataDlg[3].nUserData);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nTestForever",m_TestDlg[3].nTestForever);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nStopTime",m_TestDlg[3].nStopTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nStopError",m_TestDlg[3].nStopError);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nLoopTest",m_TestDlg[3].nLoopTest);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].nDisONOFF",m_TestDlg[3].nDisONOFF);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].strHrTime",m_itoaRegistry[3].strHrTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[3].strMinTime",m_itoaRegistry[3].strMinTime);

	m_itoaRegistry[4].strHrTime=atoi(m_TestDlg[0].strHrTime);
	m_itoaRegistry[4].strMinTime=atoi(m_TestDlg[0].strMinTime);

	WriteProfileInt("Version 1.0","m_PortRegistry[4].nPortOpen",m_structPortSettingsDlg[4].nPortOpen);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nBaud",m_structPortSettingsDlg[4].nBaud);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nDataBits",m_structPortSettingsDlg[4].nDataBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nParity",m_structPortSettingsDlg[4].nParity);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nStopBits",m_structPortSettingsDlg[4].nStopBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nFlowCtrl",m_structPortSettingsDlg[4].nFlowCtrl);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nComBase",m_structPortSettingsDlg[4].nComBase);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nRS485",m_structPortSettingsDlg[4].nRS485);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nIR",m_structPortSettingsDlg[4].nIR);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nDTR",m_structPortSettingsDlg[4].nDTR);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nDTRHys",m_structPortSettingsDlg[4].nDTRHys);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nRTS",m_structPortSettingsDlg[4].nRTS);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nRTSHys",m_structPortSettingsDlg[4].nRTSHys);	
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nTxFIFO",m_structPortSettingsDlg[4].nTxFIFO);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nTxTrig",m_structPortSettingsDlg[4].nTxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nRxFIFO",m_structPortSettingsDlg[4].nRxFIFO);		
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nRxTrig",m_structPortSettingsDlg[4].nRxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nQuickBrown",m_TransferDataDlg[4].nQuickBrown);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nAlpha",m_TransferDataDlg[4].nAlpha);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nFile",m_TransferDataDlg[4].nFile);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nUserData",m_TransferDataDlg[4].nUserData);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nTestForever",m_TestDlg[4].nTestForever);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nStopTime",m_TestDlg[4].nStopTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nStopError",m_TestDlg[4].nStopError);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nLoopTest",m_TestDlg[4].nLoopTest);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].nDisONOFF",m_TestDlg[4].nDisONOFF);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].strHrTime",m_itoaRegistry[4].strHrTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[4].strMinTime",m_itoaRegistry[4].strMinTime);

	m_itoaRegistry[5].strHrTime=atoi(m_TestDlg[5].strHrTime);
	m_itoaRegistry[5].strMinTime=atoi(m_TestDlg[5].strMinTime);

	WriteProfileInt("Version 1.0","m_PortRegistry[5].nPortOpen",m_structPortSettingsDlg[5].nPortOpen);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nBaud",m_structPortSettingsDlg[5].nBaud);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nDataBits",m_structPortSettingsDlg[5].nDataBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nParity",m_structPortSettingsDlg[5].nParity);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nStopBits",m_structPortSettingsDlg[5].nStopBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nFlowCtrl",m_structPortSettingsDlg[5].nFlowCtrl);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nComBase",m_structPortSettingsDlg[5].nComBase);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nRS485",m_structPortSettingsDlg[5].nRS485);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nIR",m_structPortSettingsDlg[5].nIR);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nDTR",m_structPortSettingsDlg[5].nDTR);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nDTRHys",m_structPortSettingsDlg[5].nDTRHys);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nRTS",m_structPortSettingsDlg[5].nRTS);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nRTSHys",m_structPortSettingsDlg[5].nRTSHys);	
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nTxFIFO",m_structPortSettingsDlg[5].nTxFIFO);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nTxTrig",m_structPortSettingsDlg[5].nTxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nRxFIFO",m_structPortSettingsDlg[5].nRxFIFO);		
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nRxTrig",m_structPortSettingsDlg[5].nRxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nQuickBrown",m_TransferDataDlg[5].nQuickBrown);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nAlpha",m_TransferDataDlg[5].nAlpha);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nFile",m_TransferDataDlg[5].nFile);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nUserData",m_TransferDataDlg[5].nUserData);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nTestForever",m_TestDlg[5].nTestForever);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nStopTime",m_TestDlg[5].nStopTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nStopError",m_TestDlg[5].nStopError);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nLoopTest",m_TestDlg[5].nLoopTest);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].nDisONOFF",m_TestDlg[5].nDisONOFF);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].strHrTime",m_itoaRegistry[5].strHrTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[5].strMinTime",m_itoaRegistry[5].strMinTime);

	m_itoaRegistry[6].strHrTime=atoi(m_TestDlg[6].strHrTime);
	m_itoaRegistry[6].strMinTime=atoi(m_TestDlg[6].strMinTime);

	WriteProfileInt("Version 1.0","m_PortRegistry[6].nPortOpen",m_structPortSettingsDlg[6].nPortOpen);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nBaud",m_structPortSettingsDlg[6].nBaud);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nDataBits",m_structPortSettingsDlg[6].nDataBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nParity",m_structPortSettingsDlg[6].nParity);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nStopBits",m_structPortSettingsDlg[6].nStopBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nFlowCtrl",m_structPortSettingsDlg[6].nFlowCtrl);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nComBase",m_structPortSettingsDlg[6].nComBase);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nRS485",m_structPortSettingsDlg[6].nRS485);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nIR",m_structPortSettingsDlg[6].nIR);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nDTR",m_structPortSettingsDlg[6].nDTR);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nDTRHys",m_structPortSettingsDlg[6].nDTRHys);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nRTS",m_structPortSettingsDlg[6].nRTS);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nRTSHys",m_structPortSettingsDlg[6].nRTSHys);	
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nTxFIFO",m_structPortSettingsDlg[6].nTxFIFO);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nTxTrig",m_structPortSettingsDlg[6].nTxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nRxFIFO",m_structPortSettingsDlg[6].nRxFIFO);		
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nRxTrig",m_structPortSettingsDlg[6].nRxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nQuickBrown",m_TransferDataDlg[6].nQuickBrown);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nAlpha",m_TransferDataDlg[6].nAlpha);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nFile",m_TransferDataDlg[6].nFile);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nUserData",m_TransferDataDlg[6].nUserData);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nTestForever",m_TestDlg[6].nTestForever);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nStopTime",m_TestDlg[6].nStopTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nStopError",m_TestDlg[6].nStopError);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nLoopTest",m_TestDlg[6].nLoopTest);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].nDisONOFF",m_TestDlg[6].nDisONOFF);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].strHrTime",m_itoaRegistry[6].strHrTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[6].strMinTime",m_itoaRegistry[6].strMinTime);

	m_itoaRegistry[7].strHrTime=atoi(m_TestDlg[7].strHrTime);
	m_itoaRegistry[7].strMinTime=atoi(m_TestDlg[7].strMinTime);

	WriteProfileInt("Version 1.0","m_PortRegistry[7].nPortOpen",m_structPortSettingsDlg[7].nPortOpen);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nBaud",m_structPortSettingsDlg[7].nBaud);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nDataBits",m_structPortSettingsDlg[7].nDataBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nParity",m_structPortSettingsDlg[7].nParity);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nStopBits",m_structPortSettingsDlg[7].nStopBits);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nFlowCtrl",m_structPortSettingsDlg[7].nFlowCtrl);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nComBase",m_structPortSettingsDlg[7].nComBase);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nRS485",m_structPortSettingsDlg[7].nRS485);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nIR",m_structPortSettingsDlg[7].nIR);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nDTR",m_structPortSettingsDlg[7].nDTR);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nDTRHys",m_structPortSettingsDlg[7].nDTRHys);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nRTS",m_structPortSettingsDlg[7].nRTS);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nRTSHys",m_structPortSettingsDlg[7].nRTSHys);	
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nTxFIFO",m_structPortSettingsDlg[7].nTxFIFO);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nTxTrig",m_structPortSettingsDlg[7].nTxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nRxFIFO",m_structPortSettingsDlg[7].nRxFIFO);		
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nRxTrig",m_structPortSettingsDlg[7].nRxTrig);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nQuickBrown",m_TransferDataDlg[7].nQuickBrown);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nAlpha",m_TransferDataDlg[7].nAlpha);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nFile",m_TransferDataDlg[7].nFile);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nUserData",m_TransferDataDlg[7].nUserData);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nTestForever",m_TestDlg[7].nTestForever);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nStopTime",m_TestDlg[7].nStopTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nStopError",m_TestDlg[7].nStopError);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nLoopTest",m_TestDlg[7].nLoopTest);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].nDisONOFF",m_TestDlg[7].nDisONOFF);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].strHrTime",m_itoaRegistry[7].strHrTime);
	WriteProfileInt("Version 1.0","m_PortRegistry[7].strMinTime",m_itoaRegistry[7].strMinTime);
    
	return CWinApp::ExitInstance();
}

void CSerial758UIApp::OnUpdateTestStop(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bTestStop);
}

void CSerial758UIApp::ClosePorts()
{
	//this function is called after all the thread which are running are killed. This function
	//just enables the test start and setup menu items and closes the open ports

	m_bTestStart = TRUE;
	m_bTestStop = FALSE;
	m_bSetUp = TRUE;
	m_bSetUpCustomClock = TRUE;

	for(int m=0;m<MAXPORTS;m++)	
	{
		if(m_structPort.bPortOpenFlag[m])//if port is opened successfully
		{
			m_structPort.bPortOpenFlag[m]=0;//reset
			
			PurgeComm(m_structPort.hPortHandle[m],PURGE_TXCLEAR|PURGE_RXCLEAR|PURGE_TXABORT|PURGE_RXABORT);//PURGE_RXCLEAR
			CloseHandle(m_structPort.hPortHandle[m]);//close the port 
		}
	}
    
	CloseHandle(m_structPort.hWrite);//close the event handle
	m_PortTest.On_TestStop();

}

void CSerial758UIApp::OnSetupPortsettings() 
{
	//This member function constructs 8 pages of class CPortPage and then adds it to the
	//propertysheet portgroup and then opens the modal dialog.This dialog is a tabbed
	//dialog

	CString StrdlgError;
	StrdlgError = "Unable to display the Port Properties tabbed dialog";

	CPortSheet portgroup("Ports Properties");
	CPortPage Port1(1),Port2(2),Port3(3),Port4(4),Port5(5),Port6(6),Port7(7),Port8(8);
		
	portgroup.AddPage(&Port1);
	portgroup.AddPage(&Port2);
	portgroup.AddPage(&Port3);
	portgroup.AddPage(&Port4);
	portgroup.AddPage(&Port5);
	portgroup.AddPage(&Port6);
	portgroup.AddPage(&Port7);
	portgroup.AddPage(&Port8);	
	
	int nRet=portgroup.DoModal();	

	if((nRet != IDOK) && (nRet != IDCANCEL) && (nRet != 0xFF))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"Error",MB_OK|MB_ICONEXCLAMATION);

	if(nRet == 0xFF)// if OnButtonSetall is called in CPortPage
		OnSetupPortsettings();	
}

void CSerial758UIApp::OnUpdateSetupPortsettings(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bSetUp);
}

void CSerial758UIApp::OnUpdateTestStart(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bTestStart);
	
}

void CSerial758UIApp::OnConfigHelp() 
{
	//This function is invoked when the user presses Help Topics under Config Menu

	CString StrExecuteError;
	ShellExecute(AfxGetMainWnd()->m_hWnd,"open","758Config.doc",NULL,NULL,SW_SHOWNORMAL);
	int ExecuteError=GetLastError();
	
	if(ExecuteError==2)//if the Serial758config.hlp is missing
	{
		StrExecuteError.Format("The configuration help file for Serial driver user interface is missing");
		MessageBox(AfxGetMainWnd()->m_hWnd,StrExecuteError,"Error",MB_OK|MB_ICONEXCLAMATION);
	}		
}

void CSerial758UIApp::OnUpdateConfigLoad(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bSetUp);
	pCmdUI->Enable(m_bSetUpCustomClock);	
}

void CSerial758UIApp::OnUpdateAppExit(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable(m_bTestStart);
}

void CSerial758UIApp::OnTestDelay() 
{
	CDelayDlg dlg;
	CString StrdlgError;
	StrdlgError = "Unable to Open the delay Dialog";
	int nRet=dlg.DoModal();// creating the  dialog box
	if((nRet == IDABORT)||(nRet==(-1)))// if the function fails
		AfxGetMainWnd()->MessageBox(StrdlgError,"CellRadioUI",MB_OK|MB_ICONEXCLAMATION);
}

void CSerial758UIApp::OnSETUPCLOCKSETTINGFOR66MHZ25x() 
{
	// TODO: Add your command handler code here
	CCustomClockSettings dlgCustomClock;
	dlgCustomClock.DoModal();
}	

void CSerial758UIApp::OnUpdateSETUPCLOCKSETTINGFOR66MHZ25x(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(m_bSetUpCustomClock);	
}
